// ACF_Interface.cpp	
/* *****************************
	 *
	 * Wraps the ugly stuff when calling a DLL without the lib file
	 *
	 * Requires CoreFoundation.dll and its support dlls from a iTunes install.
	 * These are found in 
	 * C:\Program Files\Common Files\Apple\Mobile Device Support\bin\
	 *
	 * *****************************/
#include "ACF_Interface.h"
using namespace std;

ACF_Interface::ACF_Interface(void)

{
	TCHAR CurrentDir[MAX_PATH];		// Current Directory for return after dll load
	DWORD CurrentDirLength;

	hDLL = NULL;
	//
	//   Get the current directory so we can return after we load CoreFoundation
	//
	CurrentDirLength = GetCurrentDirectory(MAX_PATH,CurrentDir);
	if(!CurrentDirLength)
	{
		cout <<  "Could not GetCurrentDirectory" << endl;
		throw (1);
	}
	if(CurrentDirLength > MAX_PATH)
	{
		cout <<  "CurrentDirectory exceeds buffer size " << endl;
		throw (1);
	}
	//
	//  Change to the Corefoundation.dll directory to do the load
	//
	if(!SetCurrentDirectory("C:\\Program Files\\Common Files\\Apple\\Mobile Device Support\\bin"))
	{
		cout <<  "Could not CD to C:\\Program Files\\Common Files\\Apple\\Mobile Device Support\\bin" << endl;
		throw (1);
	}
	hDLL = LoadLibrary("CoreFoundation.dll");
	if (hDLL == NULL) 
	{
		
		cout <<  "Could not find CoreFoundation.dll " << GetLastError() << endl;
		throw (1);
	}
	//
	//  Return to the current directory
	//
	if(!SetCurrentDirectory(CurrentDir))
	{
		cout <<  "Could not return to the Startup directory" << CurrentDir  << endl;	
		throw (1);
	}
	//
	//  Load the function addresses
	//
		addr_CFWriteStreamCreateWithFile = (fn_CFWriteStreamCreateWithFile) GetProcAddress(hDLL,"CFWriteStreamCreateWithFile");
		if(!addr_CFWriteStreamCreateWithFile) {cout << "Missing Function CFWriteStreamCreateWithFile" << endl; throw(1);}
		addr_CFReadStreamCreateWithFile = (fn_CFReadStreamCreateWithFile) GetProcAddress(hDLL,"CFReadStreamCreateWithFile");
		if(!addr_CFReadStreamCreateWithFile) {cout << "Missing Function CFReadStreamCreateWithFile" << endl; throw(1);}
		addr_CFStringCreateWithCString = (fn_CFStringCreateWithCString) GetProcAddress(hDLL,"CFStringCreateWithCString");
		if(!addr_CFStringCreateWithCString) {cout << "Missing Function CFStringCreateWithCString" << endl; throw(1);}
		addr_CFURLCreateWithFileSystemPath = (fn_CFURLCreateWithFileSystemPath ) GetProcAddress(hDLL,"CFURLCreateWithFileSystemPath");
		if(!addr_CFURLCreateWithFileSystemPath) {cout << "Missing Function CFURLCreateWithFileSystemPath" << endl; throw(1);}
		addr_CFReadStreamOpen = (fn_CFReadStreamOpen ) GetProcAddress(hDLL,"CFReadStreamOpen");
		if(!addr_CFReadStreamOpen) {cout << "Missing Function CFReadStreamOpen" << endl; throw(1);}
		addr_CFWriteStreamOpen = (fn_CFWriteStreamOpen ) GetProcAddress(hDLL,"CFWriteStreamOpen");
		if(!addr_CFWriteStreamOpen) {cout << "Missing Function CFWriteStreamOpen" << endl; throw(1);}
		addr_CFPropertyListCreateFromStream = (fn_CFPropertyListCreateFromStream ) GetProcAddress(hDLL,"CFPropertyListCreateFromStream");
		if(!addr_CFPropertyListCreateFromStream) {cout << "Missing Function CFPropertyListCreateFromStream" << endl; throw(1);}
		addr_CFReadStreamClose = (fn_CFReadStreamClose ) GetProcAddress(hDLL,"CFReadStreamClose");
		if(!addr_CFReadStreamClose) {cout << "Missing Function CFReadStreamClose" << endl; throw(1);}
		addr_CFPropertyListIsValid = (fn_CFPropertyListIsValid) GetProcAddress(hDLL,"CFPropertyListIsValid");
		if(!addr_CFPropertyListIsValid) {cout << "Missing Function CFPropertyListIsValid" << endl; throw(1);}
		addr_CFPropertyListWriteToStream = (fn_CFPropertyListWriteToStream ) GetProcAddress(hDLL,"CFPropertyListWriteToStream");
		if(!addr_CFPropertyListWriteToStream) {cout << "Missing Function CFPropertyListWriteToStream" << endl; throw(1);}
		addr_CFWriteStreamClose = (fn_CFWriteStreamClose) GetProcAddress(hDLL,"CFWriteStreamClose");
		if(!addr_CFWriteStreamClose) {cout << "Missing Function CFWriteStreamClose" << endl; throw(1);}
}

ACF_Interface::~ACF_Interface(void)
{
	if (hDLL) {
	FreeLibrary(hDLL);
	}
}

CFWriteStreamRef ACF_Interface::CFWriteStreamCreateWithFile(CFAllocatorRef alloc, CFURLRef fileURL)
{return (addr_CFWriteStreamCreateWithFile) (alloc, fileURL);}

CFReadStreamRef ACF_Interface::CFReadStreamCreateWithFile(CFAllocatorRef alloc, CFURLRef fileURL)
{return (addr_CFReadStreamCreateWithFile) (alloc, fileURL);}

CFStringRef ACF_Interface::CFStringCreateWithCString (CFAllocatorRef alloc,const char *cStr,CFStringEncoding encoding)
{return (addr_CFStringCreateWithCString) (alloc, cStr, encoding);}

CFURLRef ACF_Interface::CFURLCreateWithFileSystemPath(CFAllocatorRef allocator, CFStringRef filePath, CFURLPathStyle fsType, Boolean isDirectory)
{return (addr_CFURLCreateWithFileSystemPath) (allocator, filePath, fsType, isDirectory);}

Boolean ACF_Interface::CFReadStreamOpen (CFReadStreamRef stream)
{return (addr_CFReadStreamOpen) (stream);}

Boolean ACF_Interface::CFWriteStreamOpen (CFWriteStreamRef stream)
{return (addr_CFWriteStreamOpen) (stream);}

CFPropertyListRef ACF_Interface::CFPropertyListCreateFromStream (CFAllocatorRef allocator, CFReadStreamRef stream, 
															CFIndex streamLength, CFOptionFlags mutabilityOption, 
															CFPropertyListFormat *format, CFStringRef *errorString)
{return (addr_CFPropertyListCreateFromStream ) (allocator, stream, streamLength, mutabilityOption, format, errorString);}

void ACF_Interface::CFReadStreamClose (CFReadStreamRef stream)
{return (addr_CFReadStreamClose) (stream);}

Boolean ACF_Interface::CFPropertyListIsValid (CFPropertyListRef plist,CFPropertyListFormat format)
{return (addr_CFPropertyListIsValid) (plist,format);}

CFIndex ACF_Interface::CFPropertyListWriteToStream (CFPropertyListRef propertyList, CFWriteStreamRef stream,
									CFPropertyListFormat format, CFStringRef *errorString)
{return (addr_CFPropertyListWriteToStream) (propertyList, stream, format, errorString);}

void ACF_Interface::CFWriteStreamClose (CFWriteStreamRef stream)
{return (addr_CFWriteStreamClose) (stream);}

