#ifndef __ACFINTERFACE_H__
#define __ACFINTERFACE_H__
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <iostream>
#include <CoreFoundation/Corefoundation.h>


class ACF_Interface
{


public:
	ACF_Interface(void);
	~ACF_Interface(void);
	CFWriteStreamRef CFWriteStreamCreateWithFile(CFAllocatorRef alloc, CFURLRef fileURL);
	CFReadStreamRef CFReadStreamCreateWithFile(CFAllocatorRef alloc, CFURLRef fileURL);
	CFStringRef CFStringCreateWithCString (CFAllocatorRef alloc,const char *cStr,CFStringEncoding encoding);
	CFURLRef CFURLCreateWithFileSystemPath(CFAllocatorRef allocator, CFStringRef filePath, CFURLPathStyle fsType, Boolean isDirectory) ;
	Boolean CFReadStreamOpen (CFReadStreamRef stream);
	Boolean CFWriteStreamOpen (CFWriteStreamRef stream);
	CFPropertyListRef CFPropertyListCreateFromStream (CFAllocatorRef allocator, CFReadStreamRef stream, 
														CFIndex streamLength, CFOptionFlags mutabilityOption, 
														CFPropertyListFormat *format, CFStringRef *errorString);
	void CFReadStreamClose (CFReadStreamRef stream);
	Boolean CFPropertyListIsValid (CFPropertyListRef plist,CFPropertyListFormat format);
	CFIndex CFPropertyListWriteToStream (CFPropertyListRef propertyList, CFWriteStreamRef stream,
										CFPropertyListFormat format, CFStringRef *errorString);
	void CFWriteStreamClose (CFWriteStreamRef stream);




private:

	HINSTANCE hDLL;		// Handle to DLL
	//
	// typedef function prototypes
	//
	typedef CFWriteStreamRef (*fn_CFWriteStreamCreateWithFile)(CFAllocatorRef, CFURLRef);
	typedef void (*fn_CFWriteStreamClose) (CFWriteStreamRef) ;
	typedef CFReadStreamRef (*fn_CFReadStreamCreateWithFile)(CFAllocatorRef, CFURLRef);
	typedef CFStringRef (*fn_CFStringCreateWithCString) (CFAllocatorRef, const char *, CFStringEncoding) ;
	typedef CFURLRef (*fn_CFURLCreateWithFileSystemPath) (CFAllocatorRef, CFStringRef, CFURLPathStyle, Boolean) ;
	typedef Boolean (*fn_CFReadStreamOpen) (CFReadStreamRef) ;
	typedef Boolean (*fn_CFWriteStreamOpen) (CFWriteStreamRef) ;
	typedef CFPropertyListRef (*fn_CFPropertyListCreateFromStream) (CFAllocatorRef, CFReadStreamRef, CFIndex, CFOptionFlags, 
																					CFPropertyListFormat *, CFStringRef *) ;
	typedef void (*fn_CFReadStreamClose) (CFReadStreamRef) ;
	typedef Boolean (*fn_CFPropertyListIsValid) (CFPropertyListRef,CFPropertyListFormat) ;
	typedef CFIndex (*fn_CFPropertyListWriteToStream) (CFPropertyListRef, CFWriteStreamRef, CFPropertyListFormat, CFStringRef *) ;
	//
	//  address of functions
	//
	fn_CFWriteStreamCreateWithFile addr_CFWriteStreamCreateWithFile;
	fn_CFReadStreamCreateWithFile addr_CFReadStreamCreateWithFile;
	fn_CFStringCreateWithCString addr_CFStringCreateWithCString ;
	fn_CFURLCreateWithFileSystemPath addr_CFURLCreateWithFileSystemPath ;
	fn_CFReadStreamOpen addr_CFReadStreamOpen ;
	fn_CFWriteStreamOpen addr_CFWriteStreamOpen ;
	fn_CFPropertyListCreateFromStream addr_CFPropertyListCreateFromStream ;
	fn_CFReadStreamClose addr_CFReadStreamClose ;
	fn_CFPropertyListIsValid addr_CFPropertyListIsValid ;
	fn_CFPropertyListWriteToStream addr_CFPropertyListWriteToStream ;
	fn_CFWriteStreamClose addr_CFWriteStreamClose ;

};

#endif // __ACFINTERFACE_H__

